<?php
// (C)2006 Matteo Lucarelli
// optional sections editing (links, news, ecc.)

require_once("load-save.php");

function validate($complete){

	global $err_str,$opt,$langs,$optfield;
	$err_str='';

	for ($i=0 ; $i<count($opt) ; $i++){
	
		// toglie spazi vuoti e caratteri speciali
		for ($j=0;$j<count($optfield[$_GET['optname']]);$j++){
			$opt[$i][$j]=clean_label($opt[$i][$j]);
		}
		
		for ($j=0;$j<count($langs);$j++){
			if (isset($opt[$i]['TEXT'.strtoupper($langs[$j])])){
				if (USE_RICH_TEXT=="1") $opt[$i]['TEXT'.strtoupper($langs[$j])]=RTESafe($opt[$i]['TEXT'.strtoupper($langs[$j])]);
				else $opt[$i]['TEXT'.strtoupper($langs[$j])]=clean_label($opt[$i]['TEXT'.strtoupper($langs[$j])]);
			}
		}
	}
	
	if ($complete){
		for ($i=0 ; $i<count($opt) ; $i++){
			for ($j=0;$j<count($optfield[$_GET['optname']]);$j++){

				if (isset($optfield[$_GET['optname']][$j]['required']) && $optfield[$_GET['optname']][$j]['required']==1){
				
					// avoid empty required field
					if ($opt[$i][$j]==''){
						$err_str.= STR_ERR_FIELD." : ".$optfield[$_GET['optname']][$j]['descr'];
						$opt[$i]['ERRCH']="*";
						return;
					}
					// avoid equal required fields
					for ($k=$i+1 ; $k<count($opt) ; $k++){
						if ($opt[$i][$j]==$opt[$k][$j]){
							$err_str.= STR_ERR_PATH." <b>".$opt[$k][$j]."</b>";
							$opt[$i]['ERRCH']="*";
							$opt[$k]['ERRCH']="*";
							return;			
						}
					}
				}
			}
		}
	}
}

$modified=TRUE;
$err_str='';

if (isset($_POST['opt'])) $opt=$_POST['opt'];

for ($i=0;$i<count($opt);$i++)
	for ($j=0;$j<count($langs);$j++)
		if (isset($_POST['rte'.$i.$j]))
			$opt[$i]['TEXT'.strtoupper($langs[$j])]=RTESafe($_POST['rte'.$i.$j]);

if (isset($_POST['optcount'])) $optcount=$_POST['optcount'];
if (isset($_POST['form_id'])) $form_id=$_POST['form_id'];
if (isset($_POST['sval']) && $_POST['sval']!='undefined') $_POST['cmd']=$_POST['sval']; // M$tupid-IE

if (isset($_POST['cmd'])){

	if ($_POST['cmd']=='revert'){
		opt_load($_GET['optname']);
		$optcount=count($opt);
		$modified=FALSE;
	}

	if ($_POST['cmd']=='save'){
		validate(TRUE);
		if ($err_str==''){
		
			opt_save($_GET['optname'],$_FILES,(isset($_POST['todel'])?$_POST['todel']:NULL),$form_id,$optcount);
			$modified=FALSE;
		}
	}
	
	if (substr($_POST['cmd'],0,3)=='add'){

		validate(FALSE);
		$toadd=substr($_POST['cmd'],3);
		
		// shift the others
		for ($i=count($opt);$i>$toadd;$i--) $opt[$i]=$opt[$i-1];
		
		// clean the new
		if (isset($optfield[$_GET['optname']])) for ($j=0;$j<count($optfield[$_GET['optname']]);$j++) $opt[$toadd][$j]="";
		for ($j=0;$j<count($langs);$j++) $opt[$toadd]['TEXT'.strtoupper($langs[$j])]="";
		$opt[$toadd]['IMG']="";
		$opt[$toadd]['FILE']="";
		$opt[$toadd]['CODE']=new_code($opt);		
		$optcount++;	
	}
	
	if (substr($_POST['cmd'],0,3)=='del'){
		$indextodel=substr($_POST['cmd'],3);
		for ($i=$indextodel;$i<count($opt);$i++) $opt[$i]=$opt[$i+1];
		unset($opt[count($opt)-1]);
		validate(FALSE);
		$optcount--;	
	}
	
	if (substr($_POST['cmd'],0,3)=='mov'){
		$tomov=substr($_POST['cmd'],3);
		$tmpopt=$opt[$tomov];
		$opt[$tomov]=$opt[$tomov+1];
		$opt[$tomov+1]=$tmpopt;
		validate(FALSE);
	}

}else{
	if (is_numeric(array_search($_GET["optname"],$optsection))){
		opt_load($_GET['optname']);
		$modified=FALSE;
		$optcount=count($opt);
	}else $err_str=STR_ERR_PAGE;
}

if (USE_RICH_TEXT=="1")
	for ($i=0 ; $i<count($opt) ; $i++)
		for ($j=0;$j<count($langs);$j++)
			if (isset($opt[$i]['TEXT'.strtoupper($langs[$j])]))
				$opt[$i]['TEXT'.strtoupper($langs[$j])]=RTESafe($opt[$i]['TEXT'.strtoupper($langs[$j])]);

if (!$modified||!isset($form_id)) $form_id=$_SERVER['HTTP_HOST']."-".time();

print_header_with_menu($_GET["optname"],"opt");
print_error($err_str);

if ($err_str!=STR_ERR_PAGE){

	if (USE_RICH_TEXT=="1") echo "<form method='post' enctype='multipart/form-data' action='index.php?page=optedit.php&optname=".$_GET['optname']."' onSubmit='submitForm();'>\n";
	echo "<form method='post' enctype='multipart/form-data' action='index.php?page=optedit.php&optname=".$_GET['optname']."'>\n";
	
	echo "<input type=hidden id='sval' name='sval' value='undefined'>\n"; // M$tupid-IE
	echo "<input type='hidden' name='MAX_FILE_SIZE' value=".return_bytes(ini_get("upload_max_filesize")).">\n";
	echo "<input type='hidden' name='form_id' value='".$form_id."'>\n";
	echo "<input type='hidden' name='optcount' value='".$optcount."'>\n";
	
	if (USE_RICH_TEXT=="1"){
		echo "<script language='JavaScript' type='text/javascript'>\n";
		echo "function submitForm() {\n";
		echo "	updateRTEs();\n";
		echo "	return true;\n";
		echo "}\n";
		echo "initRTE('jslib/images/', 'jslib/', '');\n";
		echo "</script>\n";
	}
	
	echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";
	echo "<button type='submit' name='cmd' value='add0' v='add0' onClick='ssval(this.v)'>".STR_ADD."</button>\n";
	if ($modified){
		echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";
	}

	if (count($opt)!=0) {

		echo "<ol>\n";
		for($i=0 ; $i<count($opt); $i++){
		
			echo "<li>";

			echo "<span class='listnumber'>".($i+1)."</span>";
			if (isset($opt[$i]['ERRCH'])) echo "<span class='error'>".$opt[$i]['ERRCH']."</span>";
			
			echo "<input type='hidden' name='opt[$i][CODE]' value='".$opt[$i]['CODE']."'>\n";
					
			echo "<table width=90%>\n";
			echo"<tr>";
			
			if (isset($optimage[$_GET['optname']]) && $optimage[$_GET['optname']]==1) echo "<td class=tdheader colspan=2>\n";
			else echo "<td class=tdheader>\n";
			
			echo "<button type='submit' name='cmd' value='del$i' v='del$i' onClick='ssval(this.v)'>X</button>\n";
			if ($i<count($opt)-1) echo "<button type='submit' name='cmd' value='mov$i' v='mov$i' onClick='ssval(this.v)'>V</button></td>\n";
			
			echo "</tr>\n<tr>\n";
			
			if ( isset($optimage[$_GET['optname']]) && $optimage[$_GET['optname']]==1){ 

				echo "<td rowspan=2 valign='bottom' align='left' width=". THUMB_MAXW .">\n";
			
				echo "<input type='hidden' name='opt[$i][IMG]' value='".$opt[$i]['IMG']."'>\n";	
																	
				if ($opt[$i]['IMG']!=""){
					if (file_exists(DATA_DIR_OPT.strtolower($_GET['optname'])."/".$opt[$i]['IMG']))
						echo "<a href='".DATA_DIR_OPT.strtolower($_GET['optname'])."/".$opt[$i]['IMG']."' target='_blank'>\n";
					if (file_exists(DATA_DIR_OPT.strtolower($_GET['optname'])."/thumb.".$opt[$i]['IMG']))
						echo "<img class='thumb' src='".DATA_DIR_OPT.strtolower($_GET['optname'])."/thumb.".$opt[$i]['IMG']."'>\n";
					if (file_exists(DATA_DIR_OPT.strtolower($_GET['optname'])."/".$opt[$i]['IMG'])) echo "</a>\n";
				}
				else echo "<img src='phplib/none.jpg'>\n";
								
				echo "</td>\n";
			}			
			
			echo "<td style='width:100%;'>\n"; // M$IE8 workaround
			
			if (isset($optfield[$_GET['optname']])){
			
				for ($j=0;$j<count($optfield[$_GET['optname']]);$j++){
				
					if ($optfield[$_GET['optname']][$j]['multilanguage']!=1)
						echo " ".$optfield[$_GET['optname']][$j]['descr'].": <input type='text' name='opt[$i][$j]' value='".$opt[$i][$j]."'><br>";
				}
			}		
			
			echo "</td>\n";
			
			echo"</tr><tr>\n";
				
			echo "<td>\n";	
			
			if (USE_JS_TABS=="1") echo "<div class='tabber'>";
			else echo "<div>";
			
			for ($j=0;$j<count($langs);$j++){
			
				if (USE_JS_TABS=="1") echo "<div class='tabbertab'>";
				else echo "<div>";
				
				if (USE_JS_TABS=="1") echo "<h2>".$langdescr[$j]."</h2>";
				
				if (isset($optfield[$_GET['optname']])){

					for ($k=0;$k<count($optfield[$_GET['optname']]);$k++){
				
						if ($optfield[$_GET['optname']][$k]['multilanguage']==1)
							echo " ".$optfield[$_GET['optname']][$k+$j]['descr'].": <input type='text' name='opt[$i][".($j+$k)."]' value='".$opt[$i][$j+$k]."'><br>\n";		
						$k += count($langs);
					}
				}	
					
				if (USE_JS_TABS!="1") echo "<br>".STR_DESCR.(count($langs)==1?"":" (".$langs[$j].")").": <br>\n";
	
				if (USE_RICH_TEXT=="1"){
					echo "<script language='JavaScript' type='text/javascript'>\n";
					echo "writeRichText('rte".$i.$j."', '".$opt[$i]['TEXT'.strtoupper($langs[$j])]."', '95%', '".THUMB_MAXH."px', true, false);\n";
					echo "</script>\n";
				}else{			
					echo "<textarea class='optdescr' name='opt[$i][TEXT".strtoupper($langs[$j])."]'>".$opt[$i]['TEXT'.strtoupper($langs[$j])]."</textarea>";
				}

				echo "</div>";
			}
		
			echo "</div></td></tr>";
			
			if (isset($optimage[$_GET['optname']]) && $optimage[$_GET['optname']]==1){
				echo "<tr>";
				echo "<td colspan=2>";
				echo STR_NEWIMAGE.":<input type='file' name='userfile$i'>";
				echo "</td>";
				echo "</tr>\n";
			}
			
			if (isset($optfile[$_GET['optname']]) && $optfile[$_GET['optname']]==1){ 
			
				echo "<tr>";

				if (isset($optimage[$_GET['optname']]) && $optimage[$_GET['optname']]==1) echo "<td colspan=2>\n";
				else echo "<td>";

				echo "<input type='hidden' name='opt[$i][FILE]' value='".$opt[$i]['FILE']."'>\n";	
				echo STR_NEWFILE.":<input type='file' name='userfileb$i'>";
				
				echo "<span class='fileinfo'>";		
				if ($opt[$i]['FILE']!=''){
					$statary=@stat(DATA_DIR_OPT.strtolower($_GET['optname'])."/".$opt[$i]['FILE']);
					echo format_stat_info($statary) ."\n";
					echo "<a class='button' href='".DATA_DIR_OPT.strtolower($_GET['optname'])."/".$opt[$i]['FILE']."'>".STR_VIEW."</a>\n";
					echo "<input type='checkbox' class='radio' name='todel[$i]'>".STR_CMD_SERVERDEL."\n";
				}else echo format_stat_info("")."\n";
				echo "</span>";
										
				echo "</td></tr>\n";		
			}

			echo "</table>\n";
		}
		echo "</ol>\n";
		echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";

		if ($modified){
			echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";
		}
	}
	echo "</form>";
}
?>


