<?php
// (C)2008 Matteo Lucarelli
// section text editing code

require_once("load-save.php");

$modified=TRUE;
$err_str='';

if (isset($_POST['form_id'])) $form_id=$_POST['form_id'];
if (isset($_POST['sval']) && $_POST['sval']!='undefined') $_POST['cmd']=$_POST['sval']; // M$tupid-iE

$descr=array();
for ($i=0;$i<count($langs);$i++){
	if (USE_RICH_TEXT=="1") $descr[$i]=RTESafe($_POST['rte'.$i]);
	else $descr[$i]=clean_label($_POST['descr'][$i]);
}

if (isset($_POST['cmd'])){
	
	if ($_POST['cmd']=='save'){
	
		if ($err_str==''){
			sectiontext_save($_GET['path'],$descr,$form_id);
			$modified=FALSE;
		}
	}
	
}else{
	if (!sectiontext_load($_GET['path'])) $err_str=STR_ERR_PAGE;
	else{
		if (USE_RICH_TEXT=="1")
			for ($i=0;$i<count($langs);$i++)
				$descr[$i]=RTESafe($descr[$i]);
	
		$modified=FALSE;
	}
}

if (!$modified||!isset($form_id)) $form_id=$_SERVER['HTTP_HOST']."-".time();

print_header_with_menu(" ".STR_OF_SECTIONTEXT." ".$_GET['path'],"sectiontext");
print_error($err_str);

if ($err_str!=STR_ERR_PAGE){

	if (USE_RICH_TEXT=="1") echo "<form method='post' enctype='multipart/form-data' action='index.php?page=sectiontextedit.php&path=".$_GET['path']."' onSubmit='submitForm();'>\n";
	else echo "<form method='post' enctype='multipart/form-data' action='index.php?page=sectiontextedit.php&path=".$_GET['path']."'>\n";
	echo "<input type=hidden id='sval' name='sval' value='undefined'>\n"; // M$tupid-iE
	echo "<input type='hidden' name='form_id' value='".$form_id."'>\n";
	
	if (USE_RICH_TEXT=="1"){
		echo "<script language='JavaScript' type='text/javascript'>\n";
		echo "function submitForm() {\n";
		echo "	updateRTEs();\n";
		echo "	return true;\n";
		echo "}\n";
		echo "initRTE('jslib/images/', 'jslib/', '');\n";
		echo "</script>\n";
	}
	
	echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v);'>".STR_CMD_SAVE."</button><br><br>\n";
	
	if (USE_JS_TABS=="1") echo "<div class='tabber'>";
	else echo "<div>";
	
	for ($i=0;$i<count($langs);$i++){
	
		if (USE_JS_TABS=="1") echo "<div class='tabbertab'>";
		else echo "<div>";
		
		echo "<h2>".$langdescr[$i]."</h2>";		
		
		if (USE_RICH_TEXT=="1"){
			echo "<script language='JavaScript' type='text/javascript'>\n";
			echo "writeRichText('rte".$i."', '".$descr[$i]."', '99%', '400px', true, false);\n";
			echo "</script>\n";
		}else{
			echo "<textarea style='{ width:800px; height:400px;}' name='descr[$i]'>".$descr[$i]."</textarea>\n";
		}
		echo "</div>";
	}
	
	echo "</div>\n";	
	echo "</form>";
}
?>


