<?php

// generic strings
define ("STR_EDIT"            ,   "Edit");
define ("STR_EDIT_MENU"       ,   "Edit Menu and Sections");
define ("STR_EDIT_IMG"        ,   "Edit Images");
define ("STR_EDIT_DOCS"       ,   "Edit Documents");
define ("STR_EDIT_TXT"        ,   "Edit Text");
define ("STR_ADD"             ,   "Add");
define ("STR_TITLE"           ,   "Title");
define ("STR_NEWFILE"         ,   "Load/Replace file");
define ("STR_NEWIMAGE"        ,   "Load/Replace image");
define ("STR_DESCR"           ,   "Description");
define ("STR_OF_SECTION"      ,   "of images of section");
define ("STR_OF_SECTIONDOCS"  ,   "of documents list of section");
define ("STR_OF_SECTIONTEXT"  ,   "of text of section");
define ("STR_NAME"            ,   "Name");
define ("STR_CONTENT_IMAGES"  ,   "Images");
define ("STR_CONTENT_DOCS"    ,   "Documents");
define ("STR_VIEW"            ,   "View");
define ("STR_SHOW_HELP"       ,   "Move the pointer on this line to show the help");

// error strings
define ("STR_ERR"             ,   "Error");
define ("STR_ERR_PATH"        ,   "Two items will have the same id:");
define ("STR_ERR_FIELD"       ,   "There are empty fields");
define ("STR_ERR_EXT"         ,   "File must have extention");
define ("STR_ERR_THUMB"       ,   "Thumbnail generation error");
define ("STR_ERR_SAVE"        ,   "Saving error");
define ("STR_ERR_MOVE"        ,   "Forbidden movement or no selected section");
define ("STR_ERR_PAGE"        ,   "REQUIRED SECTION OR PAGE DOES NOT EXISTS!");
define ("STR_ERR_LOCK"        ,   "Save in progress. Wait or reload page");

// buttons strings
define ("STR_CMD_ADDSECTION"  ,   "Add Section");
define ("STR_CMD_SAVE"        ,   "Save");
define ("STR_CMD_REVERT"      ,   "Revert to last saved version");
define ("STR_CMD_MOVEHERE"    ,   "Move Here");
define ("STR_CMD_SERVERDEL"   ,   "Delete from server");
define ("STR_SHOWCOVER"       ,   "Show cover between images");
define ("STR_USE_AS_COVER"    ,   "Use as cover image");

function print_help($page,$mode){

	if ($mode=="1") echo "<span title=\"cssbody=[warning] cssheader=[warning] fade=[on] fadespeed=[0.25] fixedrelx=[0] fixedrely=[0] body=[\n";
	else echo "<div class='warning'>";
	
	switch ($page){

	case "fix":
		echo "In this section you can modify some fixed files<br>\n";
		echo "To load files use <b>".STR_NEWFILE."</b> field<br>\n";
		echo "Use <b>".STR_CMD_SERVERDEL."</b> to delete the file without overwrite it<br>\n";		
		echo "Maximum accepted file dimension is: <b>".ini_get( "upload_max_filesize")."b</b><br>\n";
		echo "<b>Warning</b>: you must save to store your changes before change page<br>\n";
		echo "Dependig from file dimension and connection speed save can require a long time<br>\n";
		break;
	case "tree":
		echo "In this section you can modify the tree-structure<br>\n";
		echo "To undo/redo use <b>back/next</b> buttons of your browser<br>\n";
		echo "<ul><li><span class='button'>X</span> = Delete item\n";
		echo "<li><span class='button'>V</span> = Move down the item\n";
		echo "<li><span class='button'>".STR_CMD_ADDSECTION."</span> = Add a section or a subsection\n";
		if (DONT_MOVE_TREE==0) echo "<li><span class='button'>".STR_CMD_MOVEHERE."</span> = Move selected item (<input type='radio' checked>) in this section(*).<br>";
		if (USE_SECTION_IMAGES=="1") echo "<li><span class='button'>".STR_EDIT_IMG."</span> = Modify section photos (*)\n";
		if (USE_SECTION_DOCS=="1") echo "<li><span class='button'>".STR_EDIT_DOCS."</span> = Modify section documents (*)\n";
		if (USE_SECTION_DESCR=="1") echo "<li><span class='button'>".STR_EDIT_TXT."</span> = Modify section text (*)\n";
		echo "<li>(*)<small>only after save</small></ul>\n";
		echo "<b>Warning</b>: you must save to store your changes before change page<br>\n";
		break;
	case "opt":
		echo "In this section you can modify the ".$_GET['optname']." list<br>\n";
		echo "To undo/redo use <b>back/next</b> buttons of your browser<br>\n";
		echo "<ul><li><span class='button'>X</span> = Delete item\n";
		echo "<li><span class='button'>V</span> = Move down the item</ul>\n";
		echo "Maximum accepted file dimension is: <b>".ini_get( "upload_max_filesize")."b</b><br>\n";
		echo "<b>Warning</b>: you must save to store your changes before change page<br>\n";
		break;
	case "section":
		echo "In this section you can modify the section images<br>\n";
		echo "To undo/redo use <b>back/next</b> buttons of your browser<br>\n";
		echo "To load images use <b>New file</b> field<br>\n";
		echo "To preserve your quality settings image dimension are not modified<br>\n";
		echo "Click on the thumbnail to see full size image<br>\n";
		echo "<ul><li><span class='button'>X</span> = Delete item\n";
		echo "<li><span class='button'>V</span> = Move down the item\n";
		if (USE_SECTION_DOCS=="1") echo "<li><span class='button'>".STR_EDIT_DOCS."</span> = Modify section documents\n";
		if (USE_SECTION_DESCR=="1") echo "<li><span class='button'>".STR_EDIT_TXT."</span> = Modify section text\n";
		echo "</ul>Maximum accepted file dimension is: <b>".ini_get( "upload_max_filesize")."b</b><br>\n";
		echo "<b>Note</b>: for thumbnail creation maximum size to consider is the one of uncompressed image<br>\n";
		echo "<b>Warning</b>: you must save to store your changes before change page<br>\n";
		echo "Dependig from file dimension and connection speed save can require a long time<br>\n";
		break;
	case "sectiondocs":
		echo "In this section you can modify the section documents<br>\n";
		echo "To undo/redo use <b>back/next</b> buttons of your browser<br>\n";
		echo "<ul><li><span class='button'>X</span> = Delete item\n";
		echo "<li><span class='button'>V</span> = Move down the item\n";
		if (USE_SECTION_IMAGES=="1") echo "<li><span class='button'>".STR_EDIT_IMG."</span> = Modify section photos (*)\n";
		if (USE_SECTION_DESCR=="1") echo "<li><span class='button'>".STR_EDIT_TXT."</span> = Modify section text (*)\n";
		echo "</ul>Maximum accepted file dimension is: <b>".ini_get( "upload_max_filesize")."b</b><br>\n";
		echo "<b>Warning</b>: you must save to store your changes before change page<br>\n";
		echo "Dependig from file dimension and connection speed save can require a long time<br>\n";
		break;
	case "sectiontext":
		echo "In this section you can modify the section text<br>\n";
		echo "To undo/redo use <b>back/next</b> buttons of your browser<br>\n";
		echo "<ul>\n";
		if (USE_SECTION_DOCS=="1") echo "<li><span class='button'>".STR_EDIT_DOCS."</span> = Modify section documents (*)\n";
		if (USE_SECTION_IMAGES=="1") echo "<li><span class='button'>".STR_EDIT_IMG."</span> = Modify section photos (*)\n";
		echo "</ul>";
		echo "<b>Warning</b>: you must save to store your changes before change page<br>\n";
		echo "Dependig from file dimension and connection speed save can require a long time<br>\n";
		break;
	}

	if ($mode=="1") echo "]\"><img src='./jslib/help.png'><small><i>&nbsp;".STR_SHOW_HELP."</i></small></span>\n";
	else echo "</div>";
}

// to print file infos in a human readable format
function format_stat_info($statary)
{
	if ($statary)
		return "Current file: ".return_notation_bytes($statary[7],2)."b - modified ".date("d/m/y",$statary[9])." at ".date("H:i",$statary[9])." (server time)";
	else return "Current file: none";
}

?>
