<?php

// generic strings
define ("STR_EDIT"            ,   "Modifica");
define ("STR_EDIT_MENU"       ,   "Menu e Sezioni");
define ("STR_EDIT_IMG"        ,   "Immagini");
define ("STR_EDIT_DOCS"       ,   "Documenti");
define ("STR_EDIT_TXT"        ,   "Testi");
define ("STR_ADD"             ,   "+");
define ("STR_TITLE"           ,   "Titolo");
define ("STR_NEWFILE"         ,   "Carica/Sostituisci file");
define ("STR_NEWIMAGE"        ,   "Carica/Sostituisci immagine");
define ("STR_DESCR"           ,   "Descrizione");
define ("STR_OF_SECTION"      ,   "delle immagini della sezione");
define ("STR_OF_SECTIONDOCS"  ,   "dei documenti della sezione");
define ("STR_OF_SECTIONTEXT"  ,   "dei testi della sezione");
define ("STR_NAME"            ,   "Nome");
define ("STR_CONTENT_IMAGES"  ,   "Immagini");
define ("STR_CONTENT_DOCS"    ,   "Documenti");
define ("STR_VIEW"            ,   "Visualizza");
define ("STR_SHOW_HELP"       ,   "Per visualizzare l&#39;aiuto portare il mouse sopra a questa linea");

// error strings
define ("STR_ERR"             ,   "ERRORE");
define ("STR_ERR_PATH"        ,   "due elementi sono uguali:");
define ("STR_ERR_FIELD"       ,   "ci sono campi vuoti");
define ("STR_ERR_EXT"         ,   "il file deve avere estensione");
define ("STR_ERR_THUMB"       ,   "non &egrave; possibile generare l&#39;anteprima");
define ("STR_ERR_SAVE"        ,   "salvataggio fallito o incompleto");
define ("STR_ERR_MOVE"        ,   "movimento impossibile o nessuna sezione selezionata");
define ("STR_ERR_PAGE"        ,   "pagina o sezione inesistente");
define ("STR_ERR_LOCK"        ,   "salvataggio in corso. Attendere o ricaricare");

// buttons strings
define ("STR_CMD_ADDSECTION"  ,   "+");
define ("STR_CMD_SAVE"        ,   "Salva");
define ("STR_CMD_REVERT"      ,   "Torna all&#39;ultimo salvataggio");
define ("STR_CMD_MOVEHERE"    ,   "Muovi Qui");
define ("STR_CMD_SERVERDEL"   ,   "Cancella dal server");
define ("STR_SHOWCOVER"       ,   "Mostra la copertina tra le immagini della sezione");
define ("STR_USE_AS_COVER"    ,   "Usa come copertina");

function print_help($page,$mode){

	if ($mode=="1") echo "<span title=\"cssbody=[warning] cssheader=[warning] fade=[on] fadespeed=[0.25] fixedrelx=[0] fixedrely=[0] body=[\n";
	else echo "<div class='warning'>";
	
	switch ($page){

	case "fix":
		echo "In questa pagina &egrave; possibile modificare il contenuto di alcuni file fissi. \n";
		echo "Per sostituire i file usare il campo <b>".STR_NEWFILE."</b>. \n";
		echo "Per eliminare il file dal server senza sostituirlo usare <b>".STR_CMD_SERVERDEL."</b><br><br>\n";		
		echo "La dimensione massima dei file caricabili &egrave; : <b>".ini_get( "upload_max_filesize")."b</b><br><br>\n";
		echo "<b>Attenzione</b>: &egrave; necessario salvare prima di cambiare pagina. \n";
		echo "In funzione della velocit&agrave; di connessione il salvataggio pu&ograve; richiedere una lunga attesa<br>\n";
		break;
	case "tree":
		echo "In questa pagina &egrave; possibile modificare la struttura delle sezioni.<br>\n";
		echo "<ul><li><span class='button'>X</span> = Elimina l&#39;elemento\n";
		echo "<li><span class='button'>V</span> = Sposta verso il basso, scambia di posto con l&#39;elemento successivo\n";
		echo "<li><span class='button'>".STR_CMD_ADDSECTION."</span> = Aggiunge una sezione o una sottosezione\n";
		if (DONT_MOVE_TREE==0) echo "<li><span class='button'>".STR_CMD_MOVEHERE."</span> = Sposta l&#39;elemento selezionato (<input type='radio' class='radio' checked>) in questa sezione (*)<br>";
		if (USE_SECTION_IMAGES=="1") echo "<li><span class='button'>".STR_EDIT_IMG."</span> = Modifica le foto della sezione (*)\n";
		if (USE_SECTION_DOCS=="1") echo "<li><span class='button'>".STR_EDIT_DOCS."</span> = Modifica i documenti della sezione (*)\n";
		if (USE_SECTION_DESCR=="1") echo "<li><span class='button'>".STR_EDIT_TXT."</span> = Modifica i testi della sezione (*)\n";
		echo "<li>(*)<small>disponibile solo dopo il salvataggio</small></ul>\n";
		echo "<b>Attenzione</b>: &egrave; necessario salvare prima di cambiare pagina<br>\n";
		break;
	case "opt":
		echo "In questa pagina &egrave; possibile modificare il contenuto della lista ".$_GET['optname'].". \n";
		echo "Per annullare/rifare usare i tasti <b>indietro/avanti</b> del browser\n";
		echo "<ul><li><span class='button'>X</span> = Elimina l&#39;elemento\n";
		echo "<li><span class='button'>V</span> = Sposta verso il basso\n";
		echo "<li><span class='button'>".STR_ADD."</span> = Aggiunge un elemento</ul>\n";
		echo "La dimensione massima dei file caricabili &egrave; : <b>".ini_get( "upload_max_filesize")."b</b><br><br>\n";
		echo "<b>Attenzione</b>: &egrave; necessario salvare prima di cambiare pagina<br>\n";
		break;
	case "section":
		echo "In questa pagina &egrave; possibile modificare il contenuto delle sezioni. \n";
		echo "Per sostituire le immagini usare il campo <b>Nuovo file</b>. \n";
		echo "Le dimensioni dell&#39;immagine non vengono modificate. \n";
		echo "Cliccando sull&#39;immagine viene mostrata nelle dimensioni reali. <br>\n";
		echo "<ul><li><span class='button'>X</span> = Elimina l&#39;elemento\n";
		echo "<li><span class='button'>V</span> = Sposta verso il basso\n";
		echo "<li><span class='button'>".STR_ADD."</span> = Aggiunge un elemento\n";
		if (USE_SECTION_DOCS=="1") echo "<li><span class='button'>".STR_EDIT_DOCS."</span> = Modifica i documenti della sezione\n";
		if (USE_SECTION_DESCR=="1") echo "<li><span class='button'>".STR_EDIT_TXT."</span> = Modifica i testi della sezione\n";
		echo "</ul>La dimensione massima dei file caricabili &egrave; : <b>".ini_get( "upload_max_filesize")."b</b>\n";
		echo " (per le immagini va considerata la dimensione non compressa). <br><br>\n";
		echo "<b>Attenzione</b>: &egrave; necessario salvare prima di cambiare pagina. \n";
		echo "In funzione della velocit&agrave; di connessione il salvataggio pu&ograve; richiedere una lunga attesa<br>\n";
		break;
	case "sectiondocs":
		echo "In questa pagina &egrave; possibile modificare la lista documenti della sezione. \n";
		echo "Per sostituire i file usare il campo <b>Nuovo file</b><br>\n";
		echo "<ul><li><span class='button'>X</span> = Elimina l&#39;elemento\n";
		echo "<li><span class='button'>V</span> = Sposta verso il basso\n";
		echo "<li><span class='button'>".STR_ADD."</span> = Aggiunge un elemento\n";
		if (USE_SECTION_IMAGES=="1") echo "<li><span class='button'>".STR_EDIT_IMG."</span> = Modifica le foto della sezione\n";
		if (USE_SECTION_DESCR=="1") echo "<li><span class='button'>".STR_EDIT_TXT."</span> = Modifica i testi della sezione\n";
		echo "</ul>La dimensione massima dei file caricabili &egrave; : <b>".ini_get( "upload_max_filesize")."b</b><br><br>\n";
		echo "<b>Attenzione</b>: &egrave; necessario salvare prima di cambiare pagina. \n";
		echo "In funzione della velocit&agrave; di connessione il salvataggio pu&ograve; richiedere una lunga attesa<br>\n";
		break;
	case "sectiontext":
		echo "In questa pagina &egrave; possibile modificare i testi della sezione.<br>\n";
		echo "<b>Attenzione</b>: Le modifiche saranno effettive dopo il salvataggio. \n";
		echo "In funzione della velocit&agrave; di connessione il salvataggio pu&ograve; richiedere una lunga attesa<br>\n";
		break;
	}

	if ($mode=="1") echo "]\"><img src='./jslib/help.png'><small><i>&nbsp;".STR_SHOW_HELP."</i></small></span>\n";
	else echo "</div>";
}

// to print file infos in a human readable format
function format_stat_info($statary)
{
	if ($statary)
		return "File attuale: ".return_notation_bytes($statary[7],2)."b - modificato il ".date("d/m/y",$statary[9])." alle ".date("H:i",$statary[9])." (ora del server)";
	else return "File attuale: Nessuno";
}

?>
